//+---------------------------------------------------------------------+
//|                                               multiwebindicator.mq5 |
//|                                       Copyright (c) 2018, Marketeer |
//|                             https://www.mql5.com/en/users/marketeer |
//| Asynchronous Non-Blocking WebRequest Implemenation on Helper Charts |
//|                               https://www.mql5.com/ru/articles/5337 |
//+---------------------------------------------------------------------+
#property copyright   "Copyright (c) 2018, Marketeer"
#property link        "https://www.mql5.com/en/users/marketeer"
#property description "WebRequestAsync demo indicator\n"

#property indicator_chart_window
#property indicator_buffers 0
#property indicator_plots 0

sinput string Method = "GET";
sinput string URL = "https://google.com/,https://ya.ru,https://www.startpage.com/";
sinput string Headers = "User-Agent: n/a";
sinput int Timeout = 5000;

#include <multiwebobjectworker.mqh>

int urlsnum;
int doneCount;
string urls[];
uint asyncStart;

class MyWebWorkerClient : public WebWorkerClient
{
  public:
    MyWebWorkerClient(const long id): WebWorkerClient(id)
    {
    }
    
    virtual void onResult(const long code, const uchar &headers[], const uchar &text[]) override
    {
      Print(getMethod(), " ", getURL(), "\nReceived ", ArraySize(headers), " bytes in header, ", ArraySize(text), " bytes in document");
      Comment(getMethod(), " ", getURL(), "\nReceived ", ArraySize(headers), " bytes in header, ", ArraySize(text), " bytes in document");
      // uncommenting this leads to potentially bulky logs
      // Print(CharArrayToString(headers));
      // Print(CharArrayToString(text));
      
      if(++doneCount == urlsnum)
      {
        Print("> > > Async WebRequest workers finished ", urlsnum, " tasks in ", GetTickCount() - asyncStart, "ms");
      }
    }

    virtual void onError(const long code) override
    {
      Print(getWorkerChartID(), ": WebRequest error code ", code);
    }
};

ClientWebWorkersPool<MyWebWorkerClient> pool(ChartID());

void OnInit()
{
  urlsnum = StringSplit(URL, ',', urls);
  Comment("Click the chart to start downloads");
}

void OnDeinit(const int reason)
{
  Comment("");
}

int OnCalculate(const int rates_total, const int prev_calculated, const int begin, const double &price[])
{
  return 0; // dummy handler
}

void OnChartEvent(const int id, const long &lparam, const double &dparam, const string &sparam) 
{
  if(id == CHARTEVENT_CLICK) // initiate test requests by simple user action
  {
    uchar Body[];
    
    doneCount = 0;
    asyncStart = GetTickCount();
    int errors = 0;
    for(int i = 0; i < urlsnum; i++)
    {
      errors += !pool.WebRequestAsync(Method, urls[i], Headers, Timeout, Body);
    }
    
    if(errors > 0)
    {
      Print(errors, " tasks failed");
      urlsnum -= errors;
    }
  }
  else
  {
    // this handler manages all important messaging behind the scene
    pool.onChartEvent(id, lparam, dparam, sparam);
  }
}
